L13 subclass: #ExamplarLike
	instanceVariableNames: 'type '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ProtoNeedingClasstalk'!
ExamplarLike comment:
'Les exemplars de Lalonde.
J''en ai marre de mettre des commentaires, a suivre'!


!ExamplarLike methodsFor: 'accessing'!

type
	^type! !

!ExamplarLike methodsFor: 'initializing (private)'!

initializeType: aClass
	type := aClass! !

!ExamplarLike methodsFor: 'creating new examplars'!

subExamplarOfClass: aClass 
	(aClass isKindOf: ClassDescription)
		ifTrue: [^self son initializeType: aClass]
		ifFalse: [self error: 'argument must be a class']!

subExamplarOfType: aClass 
	(aClass isKindOf: ClassDescription)
		ifTrue: [^self son initializeType: aClass]
		ifFalse: [self error: 'argument must be a class']!

subExamplarOfType: aClass instanceVariables: aString 
	| new |
	(aClass isKindOf: ClassDescription)
		ifTrue: 
			[new := self son initializeType: aClass.
			(ClassBuilder new scan: aString)
				do: [:each | new addVar: each asSymbol].
			^new]
		ifFalse: [self error: 'argument must be a class']! !

!ExamplarLike methodsFor: 'printing'!

printOn: aStream
	aStream nextPutAll: 'a' , type printString , ' ('.
	variables associationsDo: [:each | each printOn: aStream. aStream nextPut: $ ].
	aStream nextPutAll: ')'.! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ExamplarLike class
	instanceVariableNames: ''!


!ExamplarLike class methodsFor: 'bootStrap'!

addPrimitivesOn: aRoot
	super addPrimitivesOn: aRoot.
	aRoot removeMethod: #son.
	aRoot addPrimitiveNamed: #subExamplarOfType:instanceVariables:.
	aRoot addPrimitiveNamed: #type.
	aRoot addPrimitiveNamed: #addMethod:.
	aRoot addPrimitiveNamed: #addMethod:classified:.
	^aRoot!

createRoot
	| root |
	root := self new initializeType: Object.
	globalVarDictionary at: #Root put: root.
	"the root will be known as objectExamplar"
	globalVarDictionary at: #ObjectExamplar put: root.
	^root! !

!ExamplarLike class methodsFor: 'example'!

example
	self run
	"
CollectionExamplar := ObjectExamplar subExamplarOfType: Collection instanceVariables: '' .


ExamplarClass create: #( name 'List' superclass Collection instanceVariables '' category 'prototypes').

EmptyListExamplar :=  CollectionExamplar subExamplarOfType: List instanceVariables: ''.

NonEmptyListExamplar :=  CollectionExamplar subExamplarOfType: List instanceVariables: 'firstPart restPart'.

List addMethod: 'empty EmptyListExamplar clone'.

List addMethod: 'nonEmpty NonEmptyListExamplar clone'.

self fileIn: 'EmptyListExamplar.st'.		
self fileIn: 'NonEmptyListExamplar.st'.

EmptyListExamplar browse.
NonEmptyListExamplar browse.

EmptyListExamplar type.

x := List empty consedWith: 2.
y := x consedWith: 3.
y append: y
"! !
