'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 1:59:08 am'!

ClassDescription subclass: #ClassTalk
	instanceVariableNames: 'name category '
	classVariableNames: 'Cv '
	poolDictionaries: ''
	category: 'Kernel-Classes'!
ClassTalk comment:
'ClassTalk-90
(c) P. Cointe Equipe mixte RXF-LITP

Instance Variables:
	superclass	<Behavior> links the chain of inheritance
	methodDict	<IdentityDictionary> associates message names with methods
	format		<Integer> encodes storage layout of instances
	subclasses	<Set> back-pointers to the class'' subclasses
	instanceVariables	<Array of: Strings> names of instance fields
	organization		<ClassOrganizer> provides organization of message protocol
	name		<ByteSymbol> name of class for printing and global reference
	category	<String>
-------------------------------------------------------------------------
Avant le boot
-------------------------------------------------------------------------
ClassDescription subclass: #ClassTalk
	instanceVariableNames: ''name category ''
	classVariableNames: ''Cv ''
	poolDictionaries: ''''
	category: ''Dea''

Object () <initialize:>
	Behavior (superclass methodDict format subclasses) <basicNew basicNew: isVariable isFixed>
		ClassDescription (instanceVariables organization) <category category: definition
			ClassTalk (name category) <create: initialize:>
			Class (name classPool sharedPools) <name>
				Object class ()
					Behavior class ()
						ClassDescription class ()
							Class class () <template:>
							ClassTalk class () <template: printMetaString isObjVlispClass initialize boot>
-------------------------------------------------------------------------
Apres le boot
-------------------------------------------------------------------------
ClassTalk create: #( 
	name	(''ClassTalk'' asSymbol)
	superclass	ClassDescription
	instanceVariables	''name category ''
	category	''ClassTalk''
	)

Object ()
	Behavior (superclass methodDict format subclasses)
		ClassDescription (instanceVariables organization)

			ClassTalk [ClassTalk] (name category)
				IndexedClass [ClassTalk] ()
				
-------------------------------------------------------------------------
Apres lecture de la premiere bibliotheque de metaclasses
-------------------------------------------------------------------------
Object ()
	Behavior (superclass methodDict format subclasses)
		ClassDescription (instanceVariables organization)

			ClassTalk [ClassTalk] (''name'' ''category'' )
				AbstractClass [ClassTalk] ()
				AccessClass [ClassTalk] ()
					AllPublicClass [AccessClass] ()
					EiffelClass [AccessClass] (''public'' )
					PublicClass [AccessClass] ()
				AccessIClass [ClassTalk] ()
					PublicIClass [AccessClass] ()
						ThingLabClass [PublicIClass] (''partsAndClasses'' ''arrayOfParts'' )
				AccessReadClass [ClassTalk] ()
					PublicReadClass [AccessReadClass] ()
				EncapsulationClass [ClassTalk] (''privateSlotNames'' )
				IndexedClass [ClassTalk] ()
				MemoClass [PublicIClass] (''allInstances'' )
					ChangeClass [ClassTalk] ()
'!


!ClassTalk methodsFor: 'who i am'!

isObjVlispClass
	^true! !

!ClassTalk methodsFor: 'private'!

category
	"ClassDescription definit les methodes category et category: qui
	gerent la variable globale SystemOrganization.
	Une classe ClassTalk connait sa categorie dans le browser"

	"^ObjVlispOrganization categoryOfElement: self name"
	^category asSymbol!

category: catString 
	"Categorize the receiver under the system category, cat, removing it from any 
	previous categorization."

	(catString isKindOf: String)
		ifTrue: 
			[ObjVlispOrganization classify: self name under: catString asSymbol.
			category_catString]
		ifFalse: [self errorCategoryName]!

name
	^name! !

!ClassTalk methodsFor: 'definition'!

definition
	"Answer a string that defines the receiver."
	^self definitionPre , self definitionBody , self definitionSelf , self definitionPost!

definitionBody
	"Answer a string that defines the Body of receiver."
	| aStream |
	aStream _ WriteStream on: (String new: 300).
	aStream nextPutAll: 'name'.
	"aStream tab; nextPutAll: '(''' , self name , ''' asSymbol)'; cr; tab."
	aStream tab; store:  self name printString; cr; tab.
	aStream nextPutAll: 'superclass'.
	aStream tab; nextPutAll: self superclass name printString; cr; tab.
	aStream nextPutAll: 'instanceVariables'; space ;tab.
	aStream store: self instanceVariablesString; cr; tab.
	aStream nextPutAll: 'category'; tab.
	category storeOn: aStream.
	"self category printString storeOn: aStream"
	^aStream contents!

definitionPost
	| aStream |
	aStream _ WriteStream on: (String new: 300).
	aStream cr; tab; nextPutAll: ')'.
	^aStream contents!

definitionPre
	"Answer a string that defines the prePart of the receiver."

	^(WriteStream on: (String new: 100)) nextPutAll: self class name printString; nextPutAll: ' create: #( '; cr; tab; contents!

definitionSelf
	"Answer a string that particularizes the receiver."
	^''! !

!ClassTalk methodsFor: 'creation'!

allocate: initArray 
	"La creation s'exprime comme la composition d'un allocateur et d'un  
	initialisateur"

	^self basicNew!

createO: initArray 
	"La creation s'exprime comme la composition d'un allocateur et d'un  
	initialisateur"

	^(self basicNew) initialize: initArray! !

!ClassTalk methodsFor: 'initialization'!

initialize: initArray 
	"Initialisation generique a la ObjVlisp: 
	On appelle le initialize general de Object puis on le specialise"

	| wasPresent previousVersion |
	super initialize: initArray.
	self setDefaultValues.
	self checkName.
	(wasPresent _ Smalltalk includesKey: name)
		ifTrue: 
			[previousVersion _ Smalltalk at: name.
			(previousVersion isKindOf: Behavior)
				ifFalse: 
					[self error: name , ' already exists!!  Proceed will store over it'.
					wasPresent _ false]].
	wasPresent ifTrue: [self reInitialize: previousVersion with: initArray].
	self
		sharedInitialize: wasPresent
		in: Smalltalk
		with: ObjVlispOrganization!

reInitialize: oldVersion with: initArray 
	methodDict _ oldVersion methodDict.
	organization _ oldVersion organization.
	self comment: oldVersion comment , '\ \ (c) Pierre Cointe\ ' withCRs , Date today printString!

sharedInitialize: wasPresent in: env with: orga


	"1 Compute and check the array of InstVarNames"
	instanceVariables _ Scanner new scanFieldNames: instanceVariables.
	self checkInstanceVariables.	
	"2 Compute the format"
	self format: self allInstVarNames size.	
	"3 update subclass lists"
	superclass addSubclass: self.	
	"4 Register the definition of the class in the global environment"
	env declare: name from: Undeclared.
	env at: name put: self.	
	"5 Register the class in the ClassTalk organization associated to its category"
	orga classify: name under: category.
	"6 Update Changes"
	wasPresent
		ifTrue: [
			env changes changeClass: self]
		ifFalse: [env changes addClass: self].
	^self! !

!ClassTalk methodsFor: 'initialization (aux)'!

checkInstanceVariables
	| usedNames iv |
	usedNames _ #('self' 'super' 'thisContext' 'true' 'false' 'nil' ) asSet.
	iv _ self allInstVarNames.
	iv do: 
		[:slot |
		(usedNames includes: slot)
			ifTrue: [self error: slot , ' is reserved (Maybe in a superclass)'].
		usedNames add: slot]!

checkMethods!

checkName
	"Dans la tradition Smalltalk, un nom de classe doit 
	obligatoirement commencer par une majuscule"

	name isString ifTrue: [name _ name asSymbol].
	name first isUppercase
		ifFalse: 
			[self error: 'Class names must be capitalized'.
			^false]!

format: nInstVars
	format _ nInstVars +
				(self isVariable
						ifTrue: [4096]
						ifFalse: [0]) +
				(self isPointers
						ifTrue: [-8192]
						ifFalse: [0])!

isPointers
	^true!

isVariable
	^false!

setDefaultValues
	"pour gerer les valeurs par defaut des slots des classes a la 
	creation de celles-ci"

	self comment: '(c) Pierre Cointe \ ' withCRs , Date today printString.
	methodDict isNil ifTrue: [methodDict _ MethodDictionary new].
	organization isNil ifTrue: [organization _ ClassOrganizer new].
	instanceVariables isNil ifTrue: [instanceVariables _ ''].
	superclass isNil ifTrue: [superclass _ Object]! !

!ClassTalk methodsFor: 'error handling'!

error: aString 
	"see Object"

	| lastNonSpace |
	lastNonSpace _ aString findLast: [:ch | ch ~= Character space].
	^self errorSignal raiseRequestErrorString: (aString copyFrom: 1 to: lastNonSpace)!

errorSignal
	"Utile apres le boot a cause du self class errorSignal de Object<errorSignal"

	^ErrorSignal!

tryCopyingCodeFor: selector
	"Une simplification de la methode de meme nom prise dans Behavior version 2.4"
	| classPart whichClass simpleSelector descr |

	selector isCompound ifFalse: [^#NotFound].
	classPart _ selector classPart.
	simpleSelector _ selector selectorPart.
	whichClass _ (Smalltalk at: classPart).
	(self inheritsFrom: whichClass) ifFalse: [^#HierarchyViolation].
	descr _ whichClass methodDescriptionAt: simpleSelector.
	descr isBad ifTrue: [^#MethodeInexistante].
	self compileUnchecked: classPart , '.' , descr sourceCode.
	^#OK! !

!ClassTalk methodsFor: 'in Class then Missimg'!

classPool
	"Redefinition de la methode classPool de Class"
	"Pour faire plaisir au Speller et autres outils"
	^Cv!

removeFromChanges
	Smalltalk changes removeClassChanges: self!

removeFromSystem
	"Forget the receiver, and all of its subclasses, from the Smalltalk global dictionary.  Any existing instances will refer to an obsolete version of the receiver."

	Smalltalk removeClassNamed: self name. 			
	ObjVlispOrganization removeElement: self name! !

!ClassTalk methodsFor: 'ClassTalk Browser'!

printHierarchy
	"En provenance de Behavior 2.4
	Pour la 2.5 il a fallu remplacer allDynamicSuperClasses par allSuperClasses"
	
	| aStream index supers |
	index _ 0.
	aStream _ WriteStream on: (String new: 16).
	self allSuperclasses reverseDo: 
		[:aClass | 
		aStream crtab: index.
		index _ index + 1.
		aStream nextPutAll: aClass name.
		aStream space.
		aStream nextPutAll: aClass printMetaString ; space.
		aStream print: aClass instVarNames.
		"aStream print: aClass selectors."
		supers _ aClass superclasses.
		supers size>1 ifTrue:
			[aStream nextPutAll: '  [also a '.
			(supers copyFrom: 2 to: supers size) do:
				[:s | aStream space; nextPutAll: s name; space; print: s allInstVarNames].
			aStream nextPut: $]  ]].
	aStream cr.
	self printSubclassesOn: aStream callingSuperclass: self superclass level: index.
	^aStream contents!

printMetaString
	^'[' , self class name printString , ']'!

printSubclassesOn: aStream callingSuperclass: whichSuper level: level 
	"As part of the algorithm for printing a description of the receiver, print the
	subclass on the file stream, aStream, indenting level times."
	| subs supers |
	aStream crtab: level.
	aStream nextPutAll: self name.
	aStream space; nextPutAll: self printMetaString.
	aStream space; print: self instVarNames.
	aStream print: self selectors.
	supers _ self superclasses.
	supers size>1 ifTrue:
		[aStream nextPutAll: '  [also a'.
		(supers copyWithout: whichSuper) do:
			[:s | aStream space; nextPutAll: s name; space; print: s allInstVarNames].
		aStream nextPut: $]  ].
	subs _ self subclasses.
	self == Class ifTrue:
		[aStream crtab: level+1; nextPutAll: '... all the Metaclasses ...'.
		subs _ subs reject: [:sub | sub isMeta]].
	"Print subclasses in alphabetical order"
	(subs asSortedCollection: [:x :y | x name < y name]) do:
		[:sub |
		sub printSubclassesOn: aStream callingSuperclass: self level: level + 1]! !

!ClassTalk methodsFor: 'predicate'!

allMetaclasses
	^ClassTalk subclasses!

isMetaClass
	^self inheritsFrom: ClassTalk

"
ClassTalk isMetaClass false
MIClass  isMetaClass true
MIPolaire isMetaClass false
AbstractClass isMetaClass true

ClassTalk subclasses
"! !

!ClassTalk methodsFor: 'bug chd prototypes'!

parent
	^nil! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassTalk class
	instanceVariableNames: ''!


!ClassTalk class methodsFor: 'browser'!

printMetaString
	"Avant le boot reste necessaire"
	^'[ClassTalk]'!

template: category
	^'ClassTalk create: #( 
		name ''NameOfClass''
		superclass SubClass
		instanceVariables ''instVarName1 instVarName2''
		category ''' , category ,''')'! !

!ClassTalk class methodsFor: 'boot'!

boot
	"ClassTalk boot"

	methodDict at: #template:  put: (self class methodDict at: #template:).
	self format: self class format.
	self changeClassToThatOf: self new.
	self category: 'Kernel-Classes'.
	"ObjVlispOrganization classify: self name under: self category."
	^self == self class!

oldBoot
	"ClassTalk oldBoot"
	ClassTalk class superclass: ClassTalk.
	self category: 'Kernel-Classes'.
	self class copyCategory: #Boot from: self classified: #Boot!

reverseBoot
	"ClassTalk reverseboot"
	ClassTalk class superclass: ClassDescription class! !

!ClassTalk class methodsFor: 'initialize'!

initialize
	"ClassTalk initialize"

	self initializeCv initializeOrganization initializeScreenController  "oldBoot".!

initializeCv
	"ClassTalk initializeCv"

	Cv _ Dictionary new.!

initializeOrganization
	"ClassTalk initializeOrganization"

	Smalltalk at: #ObjVlispOrganization put: SystemOrganizer new.!

initializeScreenController
	"ClassTalk initializeScreenController"
     | menu |
	menu _ ( ( LauncherView initializeLauncherMenu) classPool associationAt: #LauncherMenu ) value.
     LauncherView allInstances do: [:i | i model: menu copy]! !

!ClassTalk class methodsFor: 'who i am'!

isObjVlispClass
	^true! !

ClassTalk initialize!
