BrowserView subclass: #ClassTalkBrowserView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassTalk-Browser'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassTalkBrowserView class
	instanceVariableNames: ''!


!ClassTalkBrowserView class methodsFor: 'instanceCreation'!

openOn: anOrganizer 
	"Create and schedule an ObjVlisp browser on an entire collection of organized classes."

	| topView aBrowser topY bottomY topWindow |
	aBrowser _ ClassTalkBrowser new on: anOrganizer.
	topY _ 0.35.
	"change this to re-proportion system browser"
	bottomY _ 1 - topY.
	topWindow_ ScheduledWindow model: aBrowser label: 'ObjVlisp is winning again' minimumSize: 400 @ 250.
	"change this to re-proportion system browser"
	(topView _ self new)
		addCategoryView: (0 @ 0 extent: 0.25 @ topY) on: aBrowser readOnly: false;
		addClassView: (0.25 @ 0 extent: 0.25 @ topY) on: aBrowser readOnly: false;
		addProtocolView: (0.5 @ 0 extent: 0.25 @ topY) on: aBrowser readOnly: false;
		addSelectorView: (0.75 @ 0 extent: 0.25 @ topY) on: aBrowser readOnly: false;
		addTextView: (0 @ topY extent: 1.0 @ bottomY) on: aBrowser initialSelection: nil.
	topWindow component: topView.
	topWindow icon: (Icon constantNamed: #systemBrowser).
	topWindow controller open! !

BrowserView subclass: #NewClassTalkBrowserView
	instanceVariableNames: 'before '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassTalk-Browser'!


!NewClassTalkBrowserView methodsFor: 'subview creation'!

addBeforeAfterView: area on: aBrowser readOnly: ingored
	"| mid |
	mid _ (area left + area right) * 0.5.
	self addSubView: (LabeledBooleanView on: aBrowser aspect: #before
			label: 'before' asText change: #before: value: true)
		in: (area copy right: mid) borderWidth: 1.
	self addSubView: (LabeledBooleanView on: aBrowser aspect: #before
			label: 'after' asText change: #before: value: false)
		in: (area copy left: mid) borderWidth: 1"


| baseModel valueModel view mid|

mid _ (area left + area right) * 0.5.
	baseModel := (PluggableAdaptor on: aBrowser) getSelector: #before putSelector: #before:.
	valueModel := (PluggableAdaptor on: baseModel) selectValue: true.
	view := LabeledBooleanView model: valueModel.
	view label: 'before'; beToggle.
	view controller beTriggerOnUp.
	self add: view borderedIn: (area copy right: mid) .

	baseModel := (PluggableAdaptor on: aBrowser) getSelector: #before putSelector: #before:.
	valueModel := (PluggableAdaptor on: baseModel) selectValue: false.
	view := LabeledBooleanView model: valueModel.
	view label: 'after'; beToggle.
	view controller beTriggerOnUp.
	self add: view borderedIn: (area copy left: mid)!

addPrimaireView: area on: aBrowser readOnly: ingored
	"| mid |
	mid _ (area left + area right) * 0.5.
	self addSubView: (LabeledBooleanView on: aBrowser aspect: #meta
			label: 'primaire' asText change: #meta: value: false)
		in: (area copy right: mid) borderWidth: 1.
	self addSubView: (LabeledBooleanView on: aBrowser aspect: #meta
			label: 'nonprimaire' asText change: #meta: value: true)
		in: (area copy left: mid) borderWidth: 1"

	| baseModel valueModel view mid|
	mid _ (area left + area right) * 0.5.
baseModel := (PluggableAdaptor on: aBrowser) getSelector: #meta putSelector: #meta:.
	valueModel := (PluggableAdaptor on: baseModel) selectValue: true.
	view := LabeledBooleanView model: valueModel.
	view label: 'Non Primaire'; beToggle.
	view controller beTriggerOnUp.
	self add: view borderedIn: (area copy right: mid) .
	baseModel := (PluggableAdaptor on: aBrowser) getSelector: #meta putSelector: #meta:.
	valueModel := (PluggableAdaptor on: baseModel) selectValue: false.
	view := LabeledBooleanView model: valueModel.
	view label: 'Primaire'; beToggle.
	view controller beTriggerOnUp.
	self add: view borderedIn:(area copy left: mid).! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NewClassTalkBrowserView class
	instanceVariableNames: ''!


!NewClassTalkBrowserView class methodsFor: 'instanceCreation'!

openOn: anOrganizer 
	"Create and schedule an ClassTalk browser on an entire collection of 
	organized classes."

	| topWindow topView aBrowser topY bottomY metaY combY |
	aBrowser _ NewClassTalkBrowser new on: anOrganizer.
	topY _ 0.35.	"change this to re-proportion system browser"
	bottomY _ 1 - topY.
	metaY _ 0.05.
	combY _ metaY * 2.
	topWindow _ ScheduledWindow
				model: aBrowser
				label: 'ObjVlisp is winning again'
				minimumSize: 400 @ 250.	"change this to re-proportion system browser"
	(topView _ self new)
		addCategoryView: (0 @ 0 extent: 0.25 @ topY)
		on: aBrowser
		readOnly: false;
		addClassView: (0.25 @ 0 extent: 0.25 @ (topY - combY))
		on: aBrowser
		readOnly: false;
		addBeforeAfterView: (0.25 @ (topY - combY) extent: 0.25 @ metaY)
		on: aBrowser
		readOnly: false;
		addPrimaireView: (0.25 @ (topY - metaY) extent: 0.25 @ metaY)
		on: aBrowser
		readOnly: false;
		addProtocolView: (0.5 @ 0 extent: 0.25 @ topY)
		on: aBrowser
		readOnly: false;
		addSelectorView: (0.75 @ 0 extent: 0.25 @ topY)
		on: aBrowser
		readOnly: false;
		addTextView: (0 @ topY extent: 1.0 @ bottomY)
		on: aBrowser
		initialSelection: nil.
	topWindow icon: (Icon constantNamed: #systemBrowser).
	topWindow component: topView.
	topWindow controller open! !

Browser subclass: #ClassTalkBrowser
	instanceVariableNames: 'before '
	classVariableNames: 'ClassMenuB '
	poolDictionaries: ''
	category: 'ClassTalk-Browser'!


!ClassTalkBrowser methodsFor: 'text'!

text
	| text |
	textMode == #classDefinition ifTrue:
		[className == nil
			ifTrue: [^ (ClassTalk template: category) asText]
			ifFalse: [^ self selectedClass definition asText]].
	textMode == #methodDefinition ifTrue:
		[selector == nil
			ifTrue: [^ self selectedClass sourceCodeTemplate asText]
			ifFalse: [^ (self selectedClass sourceCodeAt: selector) asText
						makeSelectorBoldIn: self selectedClass]].
	textMode == #category ifTrue:
		[^ 'category to add' asText].
	textMode == #categories ifTrue:
		[^ organization printString asText].
	textMode == #protocol ifTrue:
		[^ 'protocol to add' asText].
	textMode == #protocols ifTrue:
		[^ self selectedClass organization printString asText].
	textMode == #comment ifTrue:
		[text _ self selectedClass comment asText.
		text isEmpty ifFalse: [^ text].
		self selectedClass isMeta ifTrue: [^'Select the browser switch "instance" to see the comment' asText].
		^ 'This class has no comment' asText].
	textMode == #hierarchy ifTrue:
		[^ self selectedClass printHierarchy asText].
	^ Text new! !

!ClassTalkBrowser methodsFor: 'class functions'!

inspectClass
		(Smalltalk at: className) inspect
"
instancesClass
	(Smalltalk at: className) class editRelation: #allInstances

instanciateClass
	(Smalltalk at: className) instanciate

subclassesClass
	(Smalltalk at: className) superclass editRelation: #subclasses
"! !

!ClassTalkBrowser methodsFor: 'class list'!

classMenu
	"ClassTalkBrowser flushMenus"

	className == nil ifTrue: [^nil].
	ClassMenuB == nil ifTrue:
		[ClassMenuB _ ActionMenu
			labels: 'file out\print out\spawn\spawn hierarchy
hierarchy\definition\comment\protocols
inst var refs\class var refs\class refs
find method
rename\remove
inspect' withCRs
			lines: #(4 8 11 12 14 15)
			selectors: #(fileOutClass printOutClass spawnClass spawnHierarchy  
showHierarchy editClass editComment editProtocols
browseFieldReferences browseClassVariables browseClassReferences
findMethodAndSelectAlphabetic
 renameClass removeClass inspectClass)].
	^ ClassMenuB! !

!ClassTalkBrowser methodsFor: 'before/after switch'!

before
	^before!

before: aBoolean
	self changeRequest ifFalse: [^self changed: #before].
	before_aBoolean.
	Transcript cr ; show: 'Before bascule'.
	self changed: #before.
	Transcript cr ; show: 'before :----------------->' , before printString.
	self changed: #text! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ClassTalkBrowser class
	instanceVariableNames: ''!


!ClassTalkBrowser class methodsFor: 'creation'!

new
	"comment stating purpose of message"

	
	^super new before: false! !

ClassTalkBrowser subclass: #NewClassTalkBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ClassTalk-Browser'!


!NewClassTalkBrowser methodsFor: 'text'!

text
	| text |
	textMode == #classDefinition ifTrue:
		[className == nil
			ifTrue: [^ (ClassTalk template: category) asText]
			ifFalse: [^ self selectedClass definition asText]].
	textMode == #methodDefinition ifTrue:
		[selector == nil
			ifTrue: [^ self selectedClass sourceCodeTemplate asText]
			ifFalse: [^ (self selectedMethod: selector) asText
						makeSelectorBoldIn: self selectedClass]].
	textMode == #methodCombination ifTrue:
		[self halt . selector == #before
			ifTrue: [^ (self selectedClass sourceCodeAtBefore: selector) asText
						makeSelectorBoldIn: self selectedClass]
			ifFalse: [^ (self selectedClass sourceCodeAtAfter: selector) asText
						makeSelectorBoldIn: self selectedClass]].
	textMode == #category ifTrue:
		[^ 'category to add' asText].
	textMode == #categories ifTrue:
		[^ organization printString asText].
	textMode == #protocol ifTrue:
		[^ 'protocol to add' asText].
	textMode == #protocols ifTrue:
		[^ self selectedClass organization printString asText].
	textMode == #comment ifTrue:
		[text _ self selectedClass comment asText.
		text isEmpty ifFalse: [^ text].
		self selectedClass isMeta ifTrue: [^'Select the browser switch "instance" to see the comment' asText].
		^ 'This class has no comment' asText].
	textMode == #hierarchy ifTrue:
		[^ self selectedClass printHierarchy asText].
	^ Text new! !

!NewClassTalkBrowser methodsFor: 'class functions'!

inspectClass
	(Smalltalk at: className) inspect!

instancesClass
	(Smalltalk at: className) class editRelation: #allInstances!

instanciateClass
	(Smalltalk at: className) instanciate!

nonMetaClass
	^self selectedClass!

subclassesClass
	
	(Smalltalk at: className) superclass editRelation: #subclasses! !

!NewClassTalkBrowser methodsFor: 'class list'!

classMenu
	"ClassTalkBrowser flushMenus"

	className == nil ifTrue: [^nil].
	ClassMenuB == nil ifTrue:
		[ClassMenuB _ ActionMenu
			labels: 'file out\print out\spawn\spawn hierarchy
hierarchy\definition\comment\protocols
inst var refs\class var refs\class refs
find method
rename\remove
inspect' withCRs
			lines: #(4 8 11 12 14 15)
			selectors: #(fileOutClass printOutClass spawnClass spawnHierarchy  
showHierarchy editClass editComment editProtocols
browseFieldReferences browseClassVariables browseClassReferences
findMethodAndSelectAlphabetic
renameClass removeClass inspectClass)].
	^ ClassMenuB!

selectedClass
	"Pour deconnecter le switch meta"
	className == nil
		ifTrue: [^nil]
		ifFalse: [^Smalltalk at: className]! !

!NewClassTalkBrowser methodsFor: 'method list'!

selectedMethod: aSelector 
	| aClass |
	aClass _ self selectedClass.
	meta ifFalse: [^aClass sourceCodeAt: aSelector ifAbsent: [^'\There is no primary' withCRs]]
		ifTrue: [(aClass isKindOf: CombinationClass)
				ifFalse: [^'Attention \ Cette classe n''est pas une CombinationClass!!!!!!!!' withCRs]
				ifTrue: [before
						ifTrue: [^aClass sourceCodeAtBefore: aSelector]
						ifFalse: [^aClass sourceCodeAtAfter: aSelector]]]! !

!NewClassTalkBrowser methodsFor: 'selector functions'!

acceptAfterMethod: aText from: aController 
	| newSelector |
	Transcript cr; show: 'Je compile une after'.
	newSelector _ self selectedClass compileAfter: aText classified: protocol notifying: aController.
	newSelector == nil ifTrue: [^false].
	newSelector == selector ifFalse: [self newSelectorList: newSelector].
	^true!

acceptBeforeMethod: aText from: aController 
	| newSelector |
	Transcript cr; show: 'Je compile une before'.
	newSelector _ self selectedClass compileBefore: aText classified: protocol notifying: aController.
	newSelector == nil ifTrue: [^false].
	newSelector == selector ifFalse: [self newSelectorList: newSelector].
	^true!

acceptMethod: aText from: aController 
	meta ifFalse: [^super acceptMethod: aText from: aController]
		ifTrue: [(self selectedClass isKindOf: CombinationClass)
				ifFalse: [Transcript cr ;  show: self name ,  ' n''est pas une Combination'. ^false]
				ifTrue: [before ifFalse: [^self acceptAfterMethod: aText from: aController]
						ifTrue: [^self acceptBeforeMethod: aText from: aController]]]! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NewClassTalkBrowser class
	instanceVariableNames: ''!


!NewClassTalkBrowser class methodsFor: 'creation'!

new
	"comment stating purpose of message"

	
	^super new before: false; meta: false.! !
