'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 10 March 1993 at 2:28:25 am'!



!Behavior methodsFor: '(ClassTalk) MI'!

conflictMethods
	^IdentityDictionary new!

copiedMethods
	^IdentityDictionary new!

dynamicMethodDescriptionAt: selector 
	"return a method description for the method for 'selector' 
	that would be found by dynamic lookup"

	(methodDict includesKey: selector)
		ifTrue: [^MethodDescription create setWhichClass: self setSelector: selector].
	superclass == nil ifTrue: [^NotImplementedMethod create].
	^superclass dynamicMethodDescriptionAt: selector


	"
	MethodDescription create: #(status ('methodNotImplemented' asSymbol ) )
	MethodDescription create: (Array 
	with: #selector 
	with: (Array with: #quote with: selector) 
	with: #whichClass 
	with: self name)
	"!

methodDescriptionAt: selector 
	"Answer a method description for the method for 'selector'."

	| local copied conflict |
	local _ methodDict includesKey: selector.
	copied _ self copiedMethods includesKey: selector.
	conflict _ self conflictMethods includesKey: selector.
	local & copied not & conflict not
		ifTrue: [^MethodDescription create setWhichClass: self setSelector: selector]
		ifFalse: [^self superMethodDescriptionAt: selector]

	"
	MethodDescription create: (Array 
	with: #selector 
	with: (Array with: #quote with: selector) 
	with: #whichClass 
	with: self name)
	"!

superMethodDescriptionAt: selector 
	"return a method description for the method for 'selector' 
	inherited from my superclasses"

	| descr result |
	result _ NotImplementedMethod create.
	self superclasses do: 
		[:each | 
		descr _ each methodDescriptionAt: selector.
		descr isMethodNotImplemented ifFalse: [result isMethodNotImplemented
				ifTrue: [result _ descr]
				ifFalse: [result = descr ifFalse: [ ^ConflictMethod create ]]]].
	^result

"
	MethodDescription create: #(status ('methodNotImplemented' asSymbol)) 
	MethodDescription create: #(status ('conflictingMethods' asSymbol))
"! !