'From Objectworks(r)\Smalltalk, Release 4 of 25 October 1990 on 17 May 1993 at 8:26:10 am'!



!MethodNode methodsFor: 'proto-evaluator'!

applyInternalWith: args in: context
	^block applyInternalWith: args in: context!

applyWith: args in: context 
	^AbstractProto returnFromSignal handle: [:ex | ex returnWith: ex parameter]
		do: [block applyWith: args in: context]! !

!Collection methodsFor: 'proto-evaluator'!

evlis: context
	^self collect: [:each | each eval: context]! !

!MessageNode class methodsFor: 'proto-evaluator'!

macroSelectors
	"pour reflection"
	^MacroSelectors! !

!MessageNode methodsFor: 'proto-evaluator'!

eval: context
	self  isExpanded ifFalse: [^super eval: context] ifTrue: [^expansion eval: context]!

evalInternal: context
	self  isExpanded ifFalse: [^super evalInternal: context] ifTrue: [^expansion evalInternal: context]!

receiver: r
	receiver := r.! !

!LoopNode methodsFor: 'proto-evaluator'!

eval: context
	[(condition eval: context) = negated]
		whileFalse: [body eval: context]!

evalInternal: context
	[(condition evalInternal: context) = negated]
		whileFalse: [body evalInternal: context]! !

!SimpleMessageNode methodsFor: 'proto-evaluator'!

arguments: o
	self halt.
	arguments := o!

eval: context 
	"context contains self which is the initial receiver in the current delegation 
	chain"

	| method rec args newContext owner |
	rec := receiver eval: context.
	args := arguments evlis: context.
	owner := rec lookup: selector.
	owner isNil ifTrue: [AbstractProto unknownMethod raiseWith: selector].
	method := owner compiledMethodAt: selector.
	(method isKindOf: CompiledMethod)
		ifTrue: ["this is either a call to a primitive or a smalltalk message"
			^rec perform: selector withArguments: args].
	"this is a user-defined method"
	newContext := PContext new.
	newContext at: #self put: rec.
	^method applyWith: args in: newContext!

evalInternal: context 
	"context contains self which is the initial receiver in the current delegation 
	chain"

	| method rec args newContext owner |
	rec := receiver evalInternal: context.
	args := arguments collect: [:each | each evalInternal: context].
	owner := rec methodOwner: selector.
	owner isNil ifTrue: [AbstractProto unknownMethod raiseWith: selector].
	method := owner compiledMethodAt: selector.
	(method isKindOf: CompiledMethod)
		ifTrue: ["this is either a call to a primitive or a smalltalk message"
			^rec perform: selector withArguments: args].
	"this is a user-defined method"
	newContext := PContext new.
	newContext at: #self put: rec.
	^method applyInternalWith: args in: newContext! !

!VariableNode methodsFor: 'proto-evaluator'!

eval: context
	"the default value of variables in prototalk, a variable references
	either an argument, a temporary or a global.
	variables and temp are found in the context argument"
	| client varName |
	varName := name asSymbol.
	^context at: varName
		ifAbsent: 
			[client := context at: #self.
			client globalVarValue: varName]!

evalInternal: context
	"the default value of variables in prototalk, a variable references
	either an argument, a temporary or a global.
	variables and temp are found in the context argument"
	| client varName |
	varName := name asSymbol.
	^context at: varName
		ifAbsent: 
			[client := context at: #self.
			client globalVarValue: varName]! !

!SequenceNode methodsFor: 'proto-evaluator'!

eval: context
	"not dealing with ^"
	| result  |
	temporaries isEmpty ifFalse: [temporaries do: [:each | context at: (each variable name asSymbol) put: nil]].
	statements do: [:each | result _ each eval: context].
	^result!

evalInternal: context
	"not dealing with ^"
	| result  |
	temporaries isEmpty ifFalse: [temporaries do: [:each | context at: (each variable name asSymbol) put: nil]].
	statements do: [:each | result _ each evalInternal: context].
	^result! !

!LiteralNode methodsFor: 'proto-evaluator'!

eval: context
	^value!

evalInternal: context
	^value! !

!ArithmeticLoopNode methodsFor: 'proto-evaluator'!

eval: context 
	| aux var |
	aux := initialValue eval: context.
	var := variable name asSymbol.
	context at: var put: aux.
	[aux perform: testSelector withArguments: (Array with: (limit eval: context))]
		whileTrue: 
			[body eval: context.
			aux := aux perform: stepSelector withArguments: (Array with: (increment eval: context)).
			context at: var put: aux]! !

!AssignmentNode methodsFor: 'proto-evaluator'!

declareVariable: aProto
"to be written"
| index |
	index := (PopUpMenu labels: 'global\correct it\abort' withCRs lines: #())
								startUpWithHeading:
									' declare ' asText , (association key contractTo: 20) asText allBold , ' as ' asText!

eval: context 
	| varName val client  |
	varName := variable name asSymbol.
	val := value eval: context.
	(context hasLocalVar: varName)
		ifTrue: [^context at: varName put: val]
		ifFalse: 
			[client := context at: #self.
			^client globalVar: varName put: val]!

evalInternal: context 
	| varName val client  |
	varName := variable name asSymbol.
	val := value evalInternal: context.
	(context hasLocalVar: varName)
		ifTrue: [^context at: varName put: val]
		ifFalse: 
			[client := context at: #self.
			^client globalVar: varName put: val]! !

!ConditionalNode methodsFor: 'proto-evaluator'!

eval: context
	(condition eval: context)
		ifTrue: [^trueBody eval: context]
		ifFalse: [^falseBody eval:context]!

evalInternal: context
	(condition evalInternal: context)
		ifTrue: [^trueBody evalInternal: context]
		ifFalse: [^falseBody evalInternal:context]! !

!ImplicitDelegationMN methodsFor: 'proto-evaluator'!

eval: context 
	"context contains self which is the initial receiver in the current delegation 
	chain"

	| method rec args newContext owner |
	rec := receiver eval: context.
	args := arguments evlis: context.
	owner := rec lookup: selector.
	owner isNil ifTrue: [AbstractProto unknownMethod raiseWith: selector].
	method := owner compiledMethodAt: selector.
	(method isKindOf: CompiledMethod)
		ifTrue: ["this is either a call to a primitive or a smalltalk message"
			^rec perform: selector withArguments: args].
	"this is a user-defined method"
	newContext := PContext new.
      newContext at: #self put: rec.
	newContext at: #super put: (owner parent).
	^method applyWith: args in: newContext! !

!ReturnNode methodsFor: 'proto-evaluator'!

eval: context
	AbstractProto returnFromSignal raiseWith: (value eval: context)! !

!CascadeNode methodsFor: 'proto-evaluator'!

eval: context 
	|  result |
	context at: #qwertyuiop put: (receiver eval: context).
	messages do: 
		[:m | 
		m receiver: (VariableNode new name: 'qwertyuiop').
		result := m eval: context].
	^result! !

!BlockNode methodsFor: 'proto-evaluator'!

applyInternalWith: args in: context
	1 to: arguments size do: [:i | context at: ((arguments at: i) variable name asSymbol) put: (args at: i)].
	^body evalInternal: context.!

applyWith: args in: context
	1 to: arguments size do: [:i | context at: ((arguments at: i) variable name asSymbol) put: (args at: i)].
	^body eval: context.!

eval: context
	^self!

evalInternal: context
	^self! !